/******************************************************************************
                          C++ Interface: TriangleReorder
                            -------------------
    description       :
    begin             : Mon Mar 28 2005
    author            : Martin Marinov, (C) 2005
    email             : marinov@cs.rwth-aachen.de
    copyright         : See LICENSE.txt file that comes with this distribution
 ******************************************************************************/

#ifndef __TriangleReorder_h__
#define __TriangleReorder_h__

#include <vector>
#include "Triangle.h"


namespace tr
{

class TriangleReorderImpl;

class TriangleReorder
{
private:
  TriangleReorderImpl*                      impl_;
  
public:
  TriangleReorder(Triangle* _tris, uint _n_tris, uint _n_vertices, uint _cache_size = 18);
  ~TriangleReorder();
  
  uint                                      calc_visits();
  void                                      reorder();
};

}//namespace tr

#endif//__TriangleReorder_h__
