//=============================================================================
//
//  CLASS GLTrackball
//
//=============================================================================


#ifndef ACG_GLTRACKBALL_HH
#define ACG_GLTRACKBALL_HH


//== INCLUDES =================================================================


#include "Vector.h"

//== NAMESPACES ===============================================================


namespace ACG {


//== CLASS DEFINITION =========================================================

	      

class GLTrackball
{
public:
  typedef Vec3                              Vec3f;
  
public:
   
  GLTrackball();
  ~GLTrackball() {}

  void set_center(const Vec3f& _center) { center_ = _center; }

  void mouse_press(int button, int x, int y);
  void mouse_move(int x, int y);
  void mouse_release(int button, int x, int y);


private:
  void rotation(int x, int y);
  void translation(int x, int y);
  void zoom(int x, int y);

  bool map_to_sphere(const Vec2i& _point, Vec3f& _result);


  Vec3f       center_;

  Vec2i       last_point_2D_;
  Vec3f       last_point_3D_;
  bool        last_point_ok_;

  enum { ROTATION, TRANSLATION, ZOOM }  action_;
  bool button_down_[10];
};


//=============================================================================
} // namespace ACG
//=============================================================================
#endif // ACG_GLTRACKBALL_HH defined
//=============================================================================

